# This file was auto-generated by Fern from our API Definition.

import typing

import httpx

from .core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .environment import MergeEnvironment
from .resources.accounting.client import AccountingClient, AsyncAccountingClient
from .resources.ats.client import AsyncAtsClient, AtsClient
from .resources.crm.client import AsyncCrmClient, CrmClient
from .resources.filestorage.client import AsyncFilestorageClient, FilestorageClient
from .resources.hris.client import AsyncHrisClient, HrisClient
from .resources.ticketing.client import AsyncTicketingClient, TicketingClient


class Merge:
    def __init__(
        self,
        *,
        environment: MergeEnvironment = MergeEnvironment.PRODUCTION,
        account_token: typing.Optional[str] = None,
        api_key: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._environment = environment
        self._client_wrapper = SyncClientWrapper(
            account_token=account_token, api_key=api_key, httpx_client=httpx.Client(timeout=timeout)
        )
        self.ats = AtsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.crm = CrmClient(environment=environment, client_wrapper=self._client_wrapper)
        self.filestorage = FilestorageClient(environment=environment, client_wrapper=self._client_wrapper)
        self.hris = HrisClient(environment=environment, client_wrapper=self._client_wrapper)
        self.ticketing = TicketingClient(environment=environment, client_wrapper=self._client_wrapper)
        self.accounting = AccountingClient(environment=environment, client_wrapper=self._client_wrapper)


class AsyncMerge:
    def __init__(
        self,
        *,
        environment: MergeEnvironment = MergeEnvironment.PRODUCTION,
        account_token: typing.Optional[str] = None,
        api_key: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._environment = environment
        self._client_wrapper = AsyncClientWrapper(
            account_token=account_token, api_key=api_key, httpx_client=httpx.AsyncClient(timeout=timeout)
        )
        self.ats = AsyncAtsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.crm = AsyncCrmClient(environment=environment, client_wrapper=self._client_wrapper)
        self.filestorage = AsyncFilestorageClient(environment=environment, client_wrapper=self._client_wrapper)
        self.hris = AsyncHrisClient(environment=environment, client_wrapper=self._client_wrapper)
        self.ticketing = AsyncTicketingClient(environment=environment, client_wrapper=self._client_wrapper)
        self.accounting = AsyncAccountingClient(environment=environment, client_wrapper=self._client_wrapper)
