# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ....core.datetime_utils import serialize_datetime
from .address import Address
from .phone_number import PhoneNumber
from .remote_data import RemoteData
from .remote_field import RemoteField


class Account(pydantic.BaseModel):
    """
    # The Account Object
    ### Description
    The `Account` object is used to represent a company in a CRM system.
    ### Usage Example
    TODO
    """

    owner: typing.Optional[str] = pydantic.Field(description="The account's owner.")
    name: typing.Optional[str] = pydantic.Field(description="The account's name.")
    description: typing.Optional[str] = pydantic.Field(description="The account's description.")
    industry: typing.Optional[str] = pydantic.Field(description="The account's industry.")
    website: typing.Optional[str] = pydantic.Field(description="The account's website.")
    number_of_employees: typing.Optional[int] = pydantic.Field(description="The account's number of employees.")
    addresses: typing.Optional[typing.List[Address]]
    phone_numbers: typing.Optional[typing.List[PhoneNumber]]
    last_activity_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="The last date (either most recent or furthest in the future) of when an activity occurs in an account."
    )
    remote_updated_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="When the CRM system account data was last modified by a user with a login."
    )
    remote_created_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="When the third party's account was created."
    )
    remote_was_deleted: typing.Optional[bool]
    id: typing.Optional[str]
    remote_id: typing.Optional[str] = pydantic.Field(description="The third-party API ID of the matching object.")
    modified_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="This is the datetime that this object was last updated by Merge"
    )
    field_mappings: typing.Optional[typing.Dict[str, typing.Any]]
    remote_data: typing.Optional[typing.List[RemoteData]]
    remote_fields: typing.Optional[typing.List[RemoteField]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
